{-# LANGUAGE TypeOperators,
             GADTs,  
             RankNTypes,
             FlexibleContexts,
             FlexibleInstances,
             MultiParamTypeClasses,
             UndecidableInstances #-}

import Control.Monad.Trans
import Control.Monad.Identity
import Control.Monad.State
import Control.Monad.Writer
import Data.Map
import AOP

law1 :: Monad m => AEnv (AOT m) -> m a -> m a
law1 aenv = runAOT aenv . lift 

i :: Tag
i = 1
j :: Tag
j = 2

f :: Int -> m Int 
g :: Int -> m Int 
f = undefined
g = undefined

prog x y = do  r1 <- wapp i f x
               r2 <- wapp j g y
               return (r1 + r2)

log' :: MonadWriter String m => Advice m a b
log' proceed x = do
  tell "Entering function ..."
  proceed x

test1 fPc = runAOT [(fPc, log')] (prog 5 12)

f_1 = f

c_1 f x y = do  r_1 <- f x
                r_2 <- wapp j g y
                return (r_1 + r_2)

c_ f = lift . runAOT [] . f

system' h x y = do  r_1 <- lift (h x)
                    r_2 <- wapp j g y
                    return (r_1 + r_2)

f_2 = g
c_2 h g x y = do  r_1 <- lift (h x)
                  r_2 <- g y
                  return (r_1 + r_2)